You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

195 lines
4.4 KiB

  1. #!/bin/bash
  2. # SPDX-License-Identifier: GPL-3.0+
  3. # Copyright (C) 2018, Martin Kepplinger <martink@posteo.de>
  4. RED='\033[0;31m'
  5. GREEN='\033[0;32m'
  6. NC='\033[0m'
  7. set -e
  8. have_input_image=0
  9. have_chipname=0
  10. have_backupname=0
  11. have_flasher=0
  12. usage()
  13. {
  14. echo "Skulls for the X230"
  15. echo " Run this script on an external computer with a flasher"
  16. echo " connected to the X230's top chip (closer to the display"
  17. echo " and farther from you)"
  18. echo ""
  19. echo "Usage: $0 -i <image.rom> [-c <chipname>] [-k <backup_filename>]"
  20. echo ""
  21. echo " -f <hardware_flasher>"
  22. echo " supported flashers: rpi"
  23. echo ""
  24. echo " -i <path to image to flash>"
  25. echo " -c <chipname> to use for flashrom"
  26. echo " -k <path to backup to save>"
  27. }
  28. args=$(getopt -o f:i:c:k:h -- "$@")
  29. if [ $? -ne 0 ] ; then
  30. usage
  31. exit 1
  32. fi
  33. eval set -- "$args"
  34. while [ $# -gt 0 ]
  35. do
  36. case "$1" in
  37. -f)
  38. FLASHER=$2
  39. have_flasher=1
  40. shift
  41. ;;
  42. -i)
  43. INPUT_IMAGE_PATH=$2
  44. have_input_image=1
  45. shift
  46. ;;
  47. -c)
  48. CHIPNAME=$2
  49. have_chipname=1
  50. shift
  51. ;;
  52. -k)
  53. BACKUPNAME=$2
  54. have_backupname=1
  55. shift
  56. ;;
  57. -h)
  58. usage
  59. exit 1
  60. ;;
  61. --)
  62. shift
  63. break
  64. ;;
  65. *)
  66. echo "Invalid option: $1"
  67. exit 1
  68. ;;
  69. esac
  70. shift
  71. done
  72. if [ ! "$have_input_image" -gt 0 ] ; then
  73. image_available=$(ls -1 | grep x230_coreboot_seabios | grep rom)
  74. if [ -z "${image_available}" ] ; then
  75. echo "No image file found. Please add -i <file>"
  76. echo ""
  77. usage
  78. exit 1
  79. fi
  80. prompt="file not specified. Please select a file to flash:"
  81. options=( $(find -maxdepth 1 -name x230_coreboot_seabios*rom -print0 | xargs -0) )
  82. PS3="$prompt "
  83. select INPUT_IMAGE_PATH in "${options[@]}" "Quit" ; do
  84. if (( REPLY == 1 + ${#options[@]} )) ; then
  85. exit
  86. elif (( REPLY > 0 && REPLY <= ${#options[@]} )) ; then
  87. echo "You picked $INPUT_IMAGE_PATH which is file $REPLY"
  88. break
  89. else
  90. echo "Invalid option. Try another one."
  91. fi
  92. done
  93. fi
  94. if [ ! "$have_flasher" -gt 0 ] ; then
  95. echo "Please select the hardware you use:"
  96. PS3='Please select the hardware flasher: '
  97. options=("Raspberry Pi" "CH341A" "Quit")
  98. select opt in "${options[@]}"
  99. do
  100. case $opt in
  101. "Raspberry Pi")
  102. FLASHER="rpi"
  103. break
  104. ;;
  105. "CH341A")
  106. FLASHER="ch341a"
  107. break
  108. ;;
  109. "Quit")
  110. exit 0
  111. ;;
  112. *) echo invalid option;;
  113. esac
  114. done
  115. fi
  116. if [ "${FLASHER}" = "rpi" ] ; then
  117. echo "Ok. Run this on a Rasperry Pi."
  118. elif [ "${FLASHER}" = "ch341a" ] ; then
  119. echo "The CH341A is not yet supported"
  120. exit 0
  121. else
  122. exit 1
  123. fi
  124. TEMP_DIR=`mktemp -d`
  125. if [ ! "$have_chipname" -gt 0 ] ; then
  126. echo "trying to detect the chip..."
  127. flashrom -p linux_spi:dev=/dev/spidev0.0,spispeed=128 &> ${TEMP_DIR}/chips || true
  128. flashrom_error=""
  129. flashrom_error=$(cat ${TEMP_DIR}/chips | grep -i error || true)
  130. if [ ! -z "${flashrom_error}" ] ; then
  131. cat ${TEMP_DIR}/chips
  132. rm -rf ${TEMP_DIR}
  133. exit 1
  134. fi
  135. CHIPNAME=""
  136. chip_found=0
  137. CHIPNAME=$(cat ${TEMP_DIR}/chips | grep Found | grep "MX25L3206E" | grep -o '".*"' || true)
  138. if [ ! -z "${CHIPNAME}" ] ; then
  139. chip_found=1
  140. fi
  141. if [ ! "$chip_found" -gt 0 ] ; then
  142. echo "chip not detected."
  143. flashrom -p linux_spi:dev=/dev/spidev0.0,spispeed=128
  144. rm -rf ${TEMP_DIR}
  145. echo "Please find it manually in the list above and rerun with the -c parameter."
  146. exit 1
  147. else
  148. echo -e "Detected ${GREEN}${CHIPNAME}${NC}."
  149. fi
  150. fi
  151. INPUT_IMAGE_NAME=$(basename ${INPUT_IMAGE_PATH})
  152. INPUT_IMAGE_SIZE=$(wc -c <"$INPUT_IMAGE_PATH")
  153. reference_filesize=4194304
  154. if [ ! "$INPUT_IMAGE_SIZE" -eq "$reference_filesize" ] ; then
  155. echo -e "${RED}Error:${NC} input file must be 4MB of size"
  156. exit 1
  157. fi
  158. echo "verifying SPI connection by reading 2 times. please wait."
  159. if [[ ! "$TEMP_DIR" || ! -d "$TEMP_DIR" ]]; then
  160. echo "Could not create temp dir"
  161. exit 1
  162. fi
  163. flashrom -p linux_spi:dev=/dev/spidev0.0,spispeed=128 -c ${CHIPNAME} -r ${TEMP_DIR}/test1.rom
  164. flashrom -p linux_spi:dev=/dev/spidev0.0,spispeed=128 -c ${CHIPNAME} -r ${TEMP_DIR}/test2.rom
  165. cmp --silent ${TEMP_DIR}/test1.rom ${TEMP_DIR}/test2.rom
  166. if [ "$have_backupname" -gt 0 ] ; then
  167. cp ${TEMP_DIR}/test1.rom ${BACKUPNAME}
  168. echo "current image saved as ${BACKUPNAME}"
  169. fi
  170. TEMP_SIZE=$(wc -c <"$TEMP_DIR/test1.rom")
  171. if [ ! "$INPUT_IMAGE_SIZE" -eq "$TEMP_SIZE" ] ; then
  172. echo -e "${RED}Error:${NC} read image (${TEMP_SIZE}) has different size that new image $INPUT_IMAGE_NAME (${INPUT_IMAGE_SIZE})"
  173. exit 1
  174. fi
  175. rm -rf ${TEMP_DIR}
  176. echo -e "${GREEN}connection ok${NC}. flashing ${INPUT_IMAGE_NAME}"
  177. flashrom -p linux_spi:dev=/dev/spidev0.0,spispeed=128 -c ${CHIPNAME} -w ${INPUT_IMAGE_PATH}
  178. echo -e "${GREEN}DONE${NC}"